/* MAIN.C file
 * 
 * Copyright (c) 2002-2005 STMicroelectronics
 */
 #include "stm8s.h"
 #include "stm8s_gpio.h"
 #include "stm8s_delay.h"
 #include "stm8s_adc1.h"
 #include "stm8s_tim1.h"
 #include "stm8s_i2c.h"
 #include "ssd1306.h"
 
	volatile uint8_t zaryad_s = 0;
	volatile uint8_t current_set;
	volatile uint8_t voltage_set;	
	volatile uint8_t voltage_min;	
	volatile uint8_t voltage_izm;
	volatile uint8_t current_izm;	
	volatile uint8_t current_lcd;	
	volatile uint8_t count = 64;
	volatile uint16_t count1 = 0;
	volatile uint8_t count2 = 0;
	volatile uint8_t min_zap = 1;	

volatile	uint16_t u;
volatile	uint16_t i;	

		
	
	#define BYTE_0(n) ((uint8_t)((n) & (uint8_t)0xFF)) /*!< Returns the low byte of the 16-bit value */
	#define BYTE_1(n) ((uint8_t)(BYTE_0((n) >> (uint8_t)8))) /*!< Returns the second byte of the 16-bit value */

void clock_setup(void)
{
CLK_DeInit();
CLK_ClockSwitchCmd(ENABLE);	
	CLK_HSECmd(DISABLE);
	CLK_LSICmd(DISABLE);
	CLK_HSICmd(ENABLE);
	while(CLK_GetFlagStatus(CLK_FLAG_HSIRDY) == FALSE);
	
	CLK_ClockSwitchCmd(ENABLE);
	CLK_HSIPrescalerConfig(CLK_PRESCALER_HSIDIV1);
											  CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
	
	CLK_ClockSwitchConfig(CLK_SWITCHMODE_AUTO, 
											  CLK_SOURCE_HSI, 
											  DISABLE, 
											  CLK_CURRENTCLOCKSTATE_ENABLE);
	
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_I2C, ENABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_SPI, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_ADC, ENABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_AWU, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_UART1, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER1, ENABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER2, DISABLE);
	CLK_PeripheralClockConfig(CLK_PERIPHERAL_TIMER4, DISABLE);
	CLK_ClockSwitchCmd(DISABLE);
}

void Time1_init (void)
{
  TIM1->ARRH = 0x02;//  16 
  TIM1->ARRL = 0xff;// 255
  /* Set the Prescaler value */
  TIM1->PSCRH = 0;
  TIM1->PSCRL = 0;// 0
  /* Set the Repetition Counter value */
  TIM1->RCR = 0;	
  TIM1->CR1 |= TIM1_CR1_CEN;
  TIM1->CCER1 |= TIM1_CCER1_CC1E; //CH1 compare Enable
 /* Reset the Output Compare Bits & Set the Output Compare Mode */
  TIM1->CCMR1 |= (uint8_t)0x60; //110: PWM mode 1 - In up-counting, channel 1 is active as long as TIM1_CNT < TIM1_CCR1, 
  /* Reset the Output Idle state & the Output N Idle state bits */
  TIM1->OISR = 0x05;
  /* Set the Output Idle state & the Output N Idle state configuration */
  /* Set the Pulse value */
  TIM1->CCR1H = 0x00;
  TIM1->CCR1L = 0x06;
  TIM1->CCR2H = 0x00;
  TIM1->CCR2L = 0x00;
  TIM1->CCER1 |= TIM1_CCER1_CC2E; //CH1 compare Enable
  TIM1->CCMR2 |= (uint8_t)0x60; //110: PWM mode 1 - In up-counting, channel 1 is active as long as TIM1_CNT < TIM1_CCR1, 
  TIM1->BKR |= TIM1_BKR_MOE;// on outputs
 //TIM1_ITConfig(TIM1_IT_UPDATE, ENABLE); 
  TIM1->IER |= 1<<0;//Enable tim1 update interrupt
  TIM1->SR1 |= 1<<0;//Clear tim1 update interrupt flag 
  voltage_min = 100;
  enableInterrupts();
}

void InitialiseIWDG(void)
{
IWDG->KR = 0xcc;         //  Start the independent watchdog.
IWDG->KR = 0x55;         //  Allow the IWDG registers to be programmed.
IWDG->PR = 6;         //  Prescaler is 2 => each count is 250uS
IWDG->RLR = 0xFF;        //  Reload counter.
IWDG->KR = 0xaa;         //  Reset the counter.
}

void adc1_init(void)
{	
	ADC1->CR2 |= ADC1_CR2_SCAN;//scan enable
	ADC1->CR3 |= ADC1_CR3_DBUF;//bufer anable
	ADC1->CR1 &= ~(1<<0); // 
	ADC1->TDRL|= (1<<3)|(1<<4)|(1<<5); // disable Schmitt trigger on AD
    //ADC1->CSR &= (uint8_t)(~ADC1_CSR_CH);
    /* Select the ADC1 channel */
    ADC1->CSR = 5;//adc channel 5
	ADC1->CR2 &= ~(1<<3); // Left Aligned Data
	ADC1->CR1 &= ~(1<<4)|(1<<5)|(1<<6); // ADC Start Conversion	111 fcu/18
	ADC1->CR1 &= ~(1<<1); //singe mode
	ADC1->CR1 |= (1<<0); // ADC ON 		 
}
void adc1_init_awd(void){
	ADC1->CR1 &= ~(1<<0); // 
	ADC1->CR2 &= ADC1_CR2_SCAN;//scan disable
	ADC1->CR3 &= ADC1_CR3_DBUF;//bufer disable
	ADC1->CR1 &= ~(1<<1); //singe mode
	ADC1->CSR |= (uint8_t)(3);//adc channel 3
	ADC1->CR1 |= (1<<0); // ADC ON
}

uint16_t adc16(uint8_t h, uint8_t l)// adc  10bit
{
uint16_t temph;
    
    temph = (uint16_t)(h << (uint8_t)2);

	temph= (uint16_t)l + (uint16_t)temph ;

return ((uint16_t)temph);
}

void bat_init (void)
{
	uint8_t u_bat;
	uint8_t urov;
	uint8_t zaryad=0;
	uint8_t chastota = 0x02;
	

ADC1_ClearFlag(ADC1_FLAG_EOC);
TIM1->CCER1 &= ~ TIM1_CCER1_CC2E; //CH2 compare disable 
TIM1->CCER1 &= ~ TIM1_CCER1_CC1E; //CH1 compare disable
adc1_init();
ADC1->CR1 |= (1<<0); // ADC ON 
while(((ADC1->CSR)&(1<<7))== 0); //  
ADC1_ClearFlag(ADC1_FLAG_EOC);
adc1_init_awd();
ADC1->CR1 |= (1<<0); // ADC ON 
while(((ADC1->CSR)&(1<<7))== 0); //  
TIM1->CCER1 |= TIM1_CCER1_CC2E; //CH1 compare Enable
TIM1->CCER1 |= TIM1_CCER1_CC1E; //CH1 compare Enable
//voltagein = ADC1->DB3RH;//3
//voltageout= ADC1->DB5RH;//5
u_bat = ADC1->DB3RH - ADC1->DB5RH;
if ( ADC1->DB3RL > ADC1->DB5RL)//   ADC     ADC         0,25..0,75 .,     
{
//u_bat++;	
}


if  (u_bat < 8)  //esli batareya <0.8v off
{
voltage_min = 100;
voltage_set = 0;
current_set = 0;
zaryad = 0;
chastota = 0x02;//  32 
}
if ((u_bat == 12)|(u_bat == 13))//  1,3    100%
{
zaryad = 68;
}
if ((u_bat == 42)|(u_bat == 43))//  4,3    100%
{
zaryad = 68;
}

if  ((u_bat > 7 ) & (u_bat < 12 ))//esli nicd to out 1.8v
{
voltage_min = 100;
voltage_set = 18;
current_set = 2;
urov = u_bat-8;
chastota = 0x01;//  32 
if (urov > 4)
{
	urov=4;
}
while (urov>0)
{
zaryad=zaryad+17;//vichuslayem indicator zaryada
urov--;
}
}

if  ((u_bat > 30 ) & (u_bat < 43 ))//esli li to out 4.4v
{
voltage_min = 120;
voltage_set = 44;
current_set = 10;
urov = u_bat-30;
chastota = 0x00;;//  64 
if (urov > 12)
{
	urov=12;
}
while (urov>0)
{
zaryad=zaryad+5;
urov--;
}
zaryad=zaryad+8;//vichuslayem indicator zaryada
}
IWDG->KR = 0xaa;//watchdog reset
if (zaryad_s != zaryad)//       
{
IWDG->KR = 0xaa;//watchdog reset
LCD_Bat(zaryad);
}
zaryad_s = zaryad;

if (u_bat < 5 )//   0,4    0,    
{
u_bat = 0;	
}

LCD_voltage(u_bat, current_lcd);//      
IWDG->KR = 0xaa;//watchdog reset
TIM1->ARRH = chastota;
TIM1->ARRL = 0xff;
}


int main()
{
clock_setup();
InitialiseIWDG();//     1 
GPIO_Init( GPIOC, GPIO_PIN_7, GPIO_MODE_OUT_PP_LOW_FAST);
GPIO_Init( GPIOC, GPIO_PIN_6, GPIO_MODE_OUT_PP_LOW_FAST);
//GPIO_Init( GPIOC, GPIO_PIN_6, GPIO_MODE_OUT_PP_LOW_FAST);
//GPIO_Init( GPIOC, GPIO_PIN_7, GPIO_MODE_OUT_PP_LOW_FAST);
//GPIO_Init( GPIOB, GPIO_PIN_4, GPIO_MODE_IN_PU_NO_IT );//knopka
//GPIO_ExternalPullUpConfig( GPIOB, GPIO_PIN_4, ENABLE);
//GPIO_Init( GPIOA, GPIO_PIN_1, GPIO_MODE_OUT_PP_HIGH_FAST);//opto
GPIO_Init( GPIOD, GPIO_PIN_3, GPIO_MODE_IN_FL_NO_IT);//voltage meas adc2 in4
GPIO_Init( GPIOD, GPIO_PIN_2, GPIO_MODE_IN_FL_NO_IT);//current mess adc1 in3
//GPIO_Init( GPIOD, GPIO_PIN_6, GPIO_MODE_IN_FL_NO_IT);//voltage set adc3 in6
GPIO_Init( GPIOD, GPIO_PIN_5, GPIO_MODE_IN_FL_NO_IT);//current set adc4 in5
GPIO_Init( GPIOC, GPIO_PIN_4, GPIO_MODE_IN_FL_NO_IT);//current set adc4 in5
adc1_init_awd();
ADC1->CR1 |= (1<<0); // ADC ON
IWDG->KR = 0xaa;//watchdog reset
Time1_init();
IWDG->KR = 0xaa;//watchdog reset
LCD_Init();
IWDG->KR = 0xaa;//watchdog reset
LCD_Clear(0x00);
LCD_Bat(0);
IWDG->KR = 0xaa;//watchdog reset
delay_ms(700);
IWDG->KR = 0xaa;//watchdog reset
		while(1)
		{
//*******************************************************************************
//count1       
if(count1 == 0)
{
//	while ( TIM1->CCR2L > 0)
//	{
TIM1->CCR2L = 0;	
//	delay_ms(1);
//	}
TIM1->ARRH = 0x02;// 32 
TIM1->ARRL = 0xff;
IWDG->KR = 0xaa;//watchdog reset
	
delay_ms(500);
	
bat_init();	
count1 = 2000;
}
//  ,    ,  adc scan 4  
TIM1->CCER1 &= ~ TIM1_CCER1_CC2E; //CH2 compare disable     
TIM1->CCER1 &= ~ TIM1_CCER1_CC1E; //CH1 compare disable
GPIO_WriteLow( GPIOC, GPIO_PIN_7);
GPIO_WriteLow( GPIOC, GPIO_PIN_6);
adc1_init();//   
ADC1->CR1 |= (1<<0); // ADC ON
while(((ADC1->CSR)&(1<<7))== 0); //  
ADC1_ClearFlag(ADC1_FLAG_EOC);
adc1_init_awd();//         ADC
ADC1->CR1 |= (1<<0); // ADC ON
while(((ADC1->CSR)&(1<<7))== 0); //  
TIM1->CCER1 |= TIM1_CCER1_CC2E; //CH1 compare Enable
TIM1->CCER1 |= TIM1_CCER1_CC1E; //CH1 compare Enable
//voltagein = ADC1->DB3RH;//3
//current = ADC1->DB4RH;//4
//voltageout= ADC1->DB5RH;//5
u=adc16(ADC1->DB5RH,ADC1->DB5RL);//      10  ADC.
i=adc16(ADC1->DB4RH,ADC1->DB4RL);//      10  ADC.

voltage_izm = ADC1->DB3RH - ADC1->DB5RH;
current_izm=(u-i);
current_izm = current_izm >> 1;
//esli tok otricatelen to on = 0;
if (u < i){
current_izm = 0;	
}

//*************************************************************************************
//  
//if (voltage_izm < voltage_set){
if (current_izm > (current_set))//       
{
if (TIM1->CCR2L > 0){
TIM1->CCR2L--;//out off	// 
}
}
// 
if (current_izm < (current_set)){
if (TIM1->CCR2L < 250)//   100% 
{
TIM1->CCR2L++;	
}
}
//}
//*************************************************************************************
//   
if (voltage_izm > voltage_set)//      
{
//TIM1->CCR1L = 3;//min podp
if (TIM1->CCR2L > 0)
{
TIM1->CCR2L=0;//out off	 
}
}
current_lcd = current_izm;
//ustranyaem drebezga 
if (current_set == (current_lcd + 1)){
current_lcd=current_set;	
}
if (current_set == (current_lcd - 1)){
current_lcd=current_set;	
}
count1--;
delay_us(1000);
IWDG->KR = 0xaa;//watchdog reset
}

}

#ifdef USE_FULL_ASSERT
 
/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param file: pointer to the source file name
  * @param line: assert_param error line source number
  * @retval : None
  */
void assert_failed(u8* file, u32 line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
 
  /* Infinite loop */
  while (1)
  {
  }
}
#endif

@far @interrupt void ADC_int_handler (void) {
 
  return;
}

@far @interrupt void TIM1_OVF_handler (void) {
TIM1->SR1 &= ~(1<<0);//Clear interruption mark
if (count == 0){
count = 50;
if (voltage_min > (ADC1->DRH-1))
{
if (TIM1->CCR1L < 100)
{
TIM1->CCR1L++;
}
}
if (voltage_min < (ADC1->DRH+1))
{
if (TIM1->CCR1L > 1 )
{
TIM1->CCR1L--;
}	
}
}
count--;
ADC1->CR1 |= (1<<0); // ADC Start Conversion
  return;
}
